<template>
    <div class="dropzone-container">
        <VueDropzone
            id="dropzone"
            ref="dropzone"
            class="dropzone__upload"
            :options="options"
            :destroy-dropzone="false"
            @vdropzone-removed-file="removeFile"
            @vdropzone-mounted="setFile"
            @vdropzone-thumbnail="updatePreview"
            @vdropzone-file-added="fileAdded"
        />
    </div>
</template>

<script>
import VueDropzone from "vue2-dropzone";
import 'vue2-dropzone/dist/vue2Dropzone.min.css';

export default {
    components: {
        VueDropzone
    },
    props: {
        url: String,
        maxFilesize: Number,
        value: [String, Object],
    },
    data() {
        return {
            file: '',
            options: {
                url: '/push/growth/popup/picture/',
                autoProcessQueue: false,
                headers: {Authorization: `Bearer ${$cookies.get('userToken')}` },
                thumbnailWidth: 120,
                thumbnailHeight: 120,
                maxFiles: 1,
                maxFilesize: 0.512,
                addRemoveLinks: true,
                acceptedFiles: "image/jpeg,image/png",
                dictRemoveFile: 'Remove',
                dictDefaultMessage: `
                <div class="dropzone-custom-content">
            <div class="d-flex justify-content-center">
                <svg
                    width="42"
                    height="42"
                    viewBox="0 0 42 42"
                    fill="none"
                    xmlns="http://www.w3.org/2000/svg"
                >
                    <path
                        d="M15.75 22.75H26.25H15.75ZM21 17.5V28V17.5ZM29.75 36.75H12.25C11.3217 36.75 10.4315 36.3813 9.77513 35.7249C9.11875 35.0685 8.75 34.1783 8.75 33.25V8.75C8.75 7.82174 9.11875 6.9315 9.77513 6.27513C10.4315 5.61875 11.3217 5.25 12.25 5.25H22.0255C22.4896 5.2501 22.9346 5.43454 23.2628 5.76275L32.7373 15.2372C33.0655 15.5654 33.2499 16.0104 33.25 16.4745V33.25C33.25 34.1783 32.8813 35.0685 32.2249 35.7249C31.5685 36.3813 30.6783 36.75 29.75 36.75Z"
                        stroke="#4786FF"
                        stroke-width="2"
                        stroke-linecap="round"
                        stroke-linejoin="round"
                    />
                </svg>
            </div>
            <div class="upload__text">
                Drag & Drop File here or <span class="upload__text upload__text_browse"> browse
                </span>
            </div>
        </div>`
            },
        }
    },
    created() {
        if(this.url) this.options.url = this.url            
        if(this.maxFilesize) this.options.maxFilesize = this.maxFilesize
    },
    methods: {
        fileAdded(file) {
            if(file) this.$emit('uploadFile', file)
        },
        updatePreview(file, response) {
            this.file = response
            this.updateFile()
        },
        removeFile() {
            this.file = ''
            this.$refs.dropzone.removeAllFiles()
            this.updateFile()
        },

        setFile(el) {
            const file = {size: 0, name: "Icon", type: "image/jpeg"}
            const url = this.value
            if (url) {
                this.$refs.dropzone.manuallyAddFile(file, url)
                this.file = file
            }
            // this.updateFile()
        },

        updateFile() {
            this.$emit('input',  this.file)
        },

    }
}
</script>

<style lang="scss" scoped>
#dropzone {
    height: 197px;
    max-height: 100%;
}
::v-deep 
{
    .upload {
        &__text {
            margin-top: 19px;
            font-size: 16px;
            line-height: 20px;
            letter-spacing: 0.3px;
            color: #9B9B9B;
            &_browse {
                color: #5D97FF;
            }
        }
    }
}
</style>

<style lang="scss" >
.dropzone__upload {
    .dropzone-custom-content {
        position: absolute;
        top: 50%;
        left: 50%;
        transform: translate(-50%, -50%);
        width: 100%;
    }
    border: 1px dashed #DAE7FF !important;
}
</style>